]> asedeno.scripts.mit.edu Git - git.git/blobdiff - git-stash.sh
Merge branch 'sh/p4'
[git.git] / git-stash.sh
index de13dd1812170ca76eb5706aefb7f59d22be6d48..534eb168abf8b0b8ae5c2195bf85b66d9cb6b21e 100755 (executable)
@@ -4,8 +4,10 @@
 USAGE='[ | list | show | apply | clear]'
 
 SUBDIRECTORY_OK=Yes
+OPTIONS_SPEC=
 . git-sh-setup
 require_work_tree
+cd_to_toplevel
 
 TMP="$GIT_DIR/.git-stash.$$"
 trap 'rm -f "$TMP-*"' 0
@@ -18,21 +20,19 @@ no_changes () {
 }
 
 clear_stash () {
-       logfile="$GIT_DIR/logs/$ref_stash" &&
-       mkdir -p "$(dirname "$logfile")" &&
-       : >"$logfile"
+       if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
+       then
+               git update-ref -d $ref_stash $current
+       fi
 }
 
-save_stash () {
+create_stash () {
        stash_msg="$1"
 
        if no_changes
        then
-               echo >&2 'No local changes to save'
                exit 0
        fi
-       test -f "$GIT_DIR/logs/$ref_stash" ||
-               clear_stash || die "Cannot initialize stash"
 
        # state of the base commit
        if b_commit=$(git rev-parse --verify HEAD)
@@ -52,7 +52,7 @@ save_stash () {
 
        # state of the index
        i_tree=$(git write-tree) &&
-       i_commit=$(printf 'index on %s' "$msg" |
+       i_commit=$(printf 'index on %s\n' "$msg" |
                git commit-tree $i_tree -p $b_commit) ||
                die "Cannot save the current index state"
 
@@ -79,6 +79,23 @@ save_stash () {
        w_commit=$(printf '%s\n' "$stash_msg" |
                git commit-tree $w_tree -p $b_commit -p $i_commit) ||
                die "Cannot record working tree state"
+}
+
+save_stash () {
+       stash_msg="$1"
+
+       if no_changes
+       then
+               echo >&2 'No local changes to save'
+               exit 0
+       fi
+       test -f "$GIT_DIR/logs/$ref_stash" ||
+               clear_stash || die "Cannot initialize stash"
+
+       create_stash "$stash_msg"
+
+       # Make sure the reflog for stash is kept.
+       : >>"$GIT_DIR/logs/$ref_stash"
 
        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
                die "Cannot save the current status"
@@ -123,19 +140,24 @@ apply_stash () {
        c_tree=$(git write-tree) ||
                die 'Cannot apply a stash in the middle of a merge'
 
+       # stash records the work tree, and is a merge between the
+       # base commit (first parent) and the index tree (second parent).
        s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
        w_tree=$(git rev-parse --verify "$s:") &&
-       b_tree=$(git rev-parse --verify "$s^:") ||
+       b_tree=$(git rev-parse --verify "$s^1:") &&
+       i_tree=$(git rev-parse --verify "$s^2:") ||
                die "$*: no valid stashed state found"
 
-       test -z "$unstash_index" || {
-               git diff --binary $s^2^..$s^2 | git apply --cached
+       unstashed_index_tree=
+       if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
+       then
+               git diff-tree --binary $s^2^..$s^2 | git apply --cached
                test $? -ne 0 &&
                        die 'Conflicts in index. Try without --index.'
                unstashed_index_tree=$(git-write-tree) ||
                        die 'Could not save index tree'
                git reset
-       }
+       fi
 
        eval "
                GITHEAD_$w_tree='Stashed changes' &&
@@ -147,18 +169,25 @@ apply_stash () {
        if git-merge-recursive $b_tree -- $c_tree $w_tree
        then
                # No conflict
-               a="$TMP-added" &&
-               git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
-               git read-tree --reset $c_tree &&
-               git update-index --add --stdin <"$a" ||
-                       die "Cannot unstage modified files"
-               git-status
-               rm -f "$a"
-               test -z "$unstash_index" || git read-tree $unstashed_index_tree
+               if test -n "$unstashed_index_tree"
+               then
+                       git read-tree "$unstashed_index_tree"
+               else
+                       a="$TMP-added" &&
+                       git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
+                       git read-tree --reset $c_tree &&
+                       git update-index --add --stdin <"$a" ||
+                               die "Cannot unstage modified files"
+                       rm -f "$a"
+               fi
+               git status || :
        else
                # Merge conflict; keep the exit status from merge-recursive
                status=$?
-               test -z "$unstash_index" || echo 'Index was not unstashed.' >&2
+               if test -n "$unstash_index"
+               then
+                       echo >&2 'Index was not unstashed.'
+               fi
                exit $status
        fi
 }
@@ -185,6 +214,13 @@ apply)
 clear)
        clear_stash
        ;;
+create)
+       if test $# -gt 0 && test "$1" = create
+       then
+               shift
+       fi
+       create_stash "$*" && echo "$w_commit"
+       ;;
 help | usage)
        usage
        ;;